qui gen w_r        =w_t

* 2-a Filter 1 period transitory deviations
	
qui gen lw_r=.
qui gen dw_r=.
qui gen wc  =.
qui gen FS1 =-200																/* dp_t + dp_t+1 */
qui gen LS1 =-200																/* dp_t-1 + dp_t */
	
qui replace lw_r       =ln(w_r)	
qui replace dw_r       =lw_r-l.lw_r 										        /* wage change */

qui replace wc       =1 if  dw_r~=0 & dw_r~=.
qui replace wc       =0 if  dw_r==0 & dw_r~=.

qui bys new_id: replace FS1=dw_r+F.dw_r if wc==1
qui bys new_id: replace LS1=dw_r+L.dw_r if wc==1

qui replace FS1=0 if abs(FS1)< $bl_tiny
qui replace LS1=0 if abs(LS1)< $bl_tiny

qui replace w_r=l.w_r if w_r~=. & l.w_r~=. & FS1==0 &  f.LS1==0 & wc==1
	
* 2- Filter 2 period  transitory deviations
	
if $bl_l >=2{
 
	qui replace lw_r=.
	qui replace dw_r=.
	qui replace wc  =.
	qui replace FS1 =-200																/* dp_t + dp_t+1 */
	qui replace LS1 =-200																/* dp_t-1 + dp_t */

	qui replace lw_r       =ln(w_r)	
	qui replace dw_r       =lw_r-l.lw_r 										        /* wage change */

	qui replace wc       =1 if  dw_r~=0 & dw_r~=.
	qui replace wc       =0 if  dw_r==0 & dw_r~=.

	qui bys new_id: replace FS1=dw_r+f.dw_r+f2.dw_r if wc==1
	qui bys new_id: replace LS1=dw_r+l.dw_r+l2.dw_r if wc==1

	qui replace FS1=0 if abs(FS1)< $bl_tiny
	qui replace LS1=0 if abs(LS1)< $bl_tiny
	
	qui replace w_r=l.w_r if w_r~=. & l.w_r~=. &   FS1==0 &  f2.LS1==0 & wc==1
	qui replace w_r=l.w_r if w_r~=. & l.w_r~=. & l.FS1==0 &  f.LS1 ==0 & l.wc==1
}

* 3- Filter 3 period  transitory deviations
	
if $bl_l >=3{
 
	qui replace lw_r=.
	qui replace dw_r=.
	qui replace wc  =.
	qui replace FS1 =-200																/* dp_t + dp_t+1 */
	qui replace LS1 =-200																/* dp_t-1 + dp_t */

	qui replace lw_r       =ln(w_r)	
	qui replace dw_r       =lw_r-l.lw_r 										        /* wage change */

	qui replace wc       =1 if  dw_r~=0 & dw_r~=.
	qui replace wc       =0 if  dw_r==0 & dw_r~=.

	qui bys new_id: replace FS1=dw_r+f.dw_r+f2.dw_r+f3.dw_r if wc==1
	qui bys new_id: replace LS1=dw_r+l.dw_r+l2.dw_r+l3.dw_r if wc==1

	qui replace FS1=0 if abs(FS1)< $bl_tiny
	qui replace LS1=0 if abs(LS1)< $bl_tiny
	
	qui replace w_r=l.w_r if w_r~=. & l.w_r~=. &   FS1==0 &  f3.LS1==0 & wc==1
	qui replace w_r=l.w_r if w_r~=. & l.w_r~=. & l1.FS1==0 &  f2.LS1 ==0 & l.wc==1
	qui replace w_r=l.w_r if w_r~=. & l.w_r~=. & l2.FS1==0 &  f.LS1 ==0 & l2.wc==1
 
}

* 4- Filter 4 period  transitory deviations

if $bl_l >=4{
 
	qui replace lw_r=.
	qui replace dw_r=.
	qui replace wc  =.
	qui replace FS1 =-200																/* dp_t + dp_t+1 */
	qui replace LS1 =-200																/* dp_t-1 + dp_t */

	qui replace lw_r       =ln(w_r)	
	qui replace dw_r       =lw_r-l.lw_r 										        /*wage change */

	qui replace wc       =1 if  dw_r~=0 & dw_r~=.
	qui replace wc       =0 if  dw_r==0 & dw_r~=.

	qui bys new_id: replace FS1=dw_r+f.dw_r+f2.dw_r+f3.dw_r+f4.dw_r if wc==1
	qui bys new_id: replace LS1=dw_r+l.dw_r+l2.dw_r+l3.dw_r+l4.dw_r if wc==1

	qui replace FS1=0 if abs(FS1)< $bl_tiny
	qui replace LS1=0 if abs(LS1)< $bl_tiny
	
	qui replace w_r=l.w_r if w_r~=. & l.w_r~=. &   FS1==0  &  f4.LS1==0 & wc==1
	qui replace w_r=l.w_r if w_r~=. & l.w_r~=. & l1.FS1==0 &  f3.LS1 ==0 & l.wc==1
	qui replace w_r=l.w_r if w_r~=. & l.w_r~=. & l2.FS1==0 &  f2.LS1 ==0 & l2.wc==1
	qui replace w_r=l.w_r if w_r~=. & l.w_r~=. & l3.FS1==0 &  f1.LS1 ==0 & l3.wc==1

}

* takeout inverse v-shape

qui replace lw_r=.
qui replace dw_r=.
qui replace wc  =.
qui replace FS1 =-200	

qui replace lw_r       =ln(w_r)	
qui replace dw_r       =lw_r-l.lw_r 										        /* wage change */

qui replace FS1=1 if  dw_r > $bl_large  & f.dw_r <(- $bl_large)
qui replace w_r=l.w_r if w_r~=. & l.w_r~=. & FS1==1 

qui drop lw_r dw_r wc FS1 LS1 
 
